﻿using Newtonsoft.Json.Linq;
using PTMedicalInsurance.Common;
using PTMedicalInsurance.Helper;
using PTMedicalInsurance.Variables;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedicalInsurance.Business
{
    class LocalMobilePayProcess : AbstractProcess
    {
        public override CallResult Process(JObject input)
        {
            //从医保平台获取患者详细的医保登记信息
            if (mIS.queryRegisterInfo(1, out outParam) != 0)
            {
                return Exception("查询患者云平台登记信息", outParam);
            }
            JObject joReg = JObject.Parse(outParam);
            Global.pat.medType = JsonHelper.getDestValue(joReg, "data.MedicalType");
            Global.pat.insuType = JsonHelper.getDestValue(joReg, "data.InsuType");

            //开始进行费用传送
            //调用HIS费用查询信息
            if (hIS.getHisFee(Global.pat, out outParam) != 0)
            {
                return Exception("获取HIS费用", outParam);
            }
            //调用医保平台转换
            JObject joHisFee = JObject.Parse(outParam);
            if (mIS.convertHisFeeWithInsuCode(joHisFee, out outParam) != 0)
            {
                return Exception("转换HIS费用", outParam);
            }

            JArray jaFeeDetail = JArray.Parse(JsonHelper.getDestValue(JObject.Parse(outParam), "data"));
            jaFeeDetail.ToList().ForEach((fee) =>
            {
                fee["chrg_bchno"] = Global.pat.adm_Dr.ToString();
                fee["med_type"] = Global.pat.medType;
            });

            JObject joInput = new JObject();
            joInput.Add("feedetail", jaFeeDetail);

            JObject joOutput = Utils.ConvertRequest<JObject>(TradeEnum.MobilePayOrder, joInput);

            outParam = JsonHelper.toJsonString(joOutput);

            return Success();
        }
    }
}
